unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Spin, ExtDlgs;

type
  TForm1 = class(TForm)
    pnl_menu: TPanel;
    pb_maluj: TPaintBox;
    btn_konec: TButton;
    spb_cara: TSpeedButton;
    spb_usecka: TSpeedButton;
    spb_smazat: TSpeedButton;
    bvl_souradnice: TBevel;
    lbl_souradnice: TLabel;
    cldlg_barva: TColorDialog;
    spe_cara: TSpinEdit;
    spb_obdelnik: TSpeedButton;
    pnl_pozadi: TPanel;
    cldlg_pozadi: TColorDialog;
    pnl_barva: TPanel;
    spb_plechovka: TSpeedButton;
    spb_kapatko: TSpeedButton;
    opd_obrazek: TOpenPictureDialog;
    spb_obrazek: TSpeedButton;
    spb_elipsa: TSpeedButton;
    procedure btn_konecClick(Sender: TObject);
    procedure pb_malujMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure pb_malujMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pb_malujMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure pnl_pozadiClick(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure spe_caraChange(Sender: TObject);
    procedure pb_malujClick(Sender: TObject);
    procedure pnl_barvaClick(Sender: TObject);
    procedure spb_obrazekClick(Sender: TObject);
    procedure spb_smazatClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    aX, aY, sX, sY, dX, dY, mys_sklik:integer;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btn_konecClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.pb_malujMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  aX:=X; // nate do globlnch hodnot
  aY:=Y;
  pb_maluj.Canvas.Brush.Color:=pnl_pozadi.Color; // nastav barvu pozad
  pb_maluj.Canvas.Pen.Color:=pnl_barva.Color; // nastav barvu pozad

  lbl_souradnice.Caption:='Souadnice: ' + IntToStr(X) + ':'+ IntToStr(Y);

  if spb_cara.Down = True then // pokud je zmknuto tlatko Cara
    begin
    if mys_sklik = 1 then pb_maluj.Canvas.LineTo(aX,aY)
      else pb_maluj.Canvas.MoveTo(aX,aY);
    end;

  if spb_usecka.Down = True then // pokud je zmknuto tlatko Usecka
    begin
      case mys_sklik of
        0:  begin
              pb_maluj.Canvas.MoveTo(sX,sY); // pesouvej kurzor na pozici, kdy nen stisknut tlatko

            end;
        1:  begin
            pb_maluj.Canvas.MoveTo(sX,sY);
            pb_maluj.Canvas.LineTo(dX,dY);
            pb_maluj.Canvas.Pen.Mode:=pmXor;
            pb_maluj.Canvas.MoveTo(sX,sY);
            pb_maluj.Canvas.LineTo(aX,aY);
            end;
    end;
   end;

  if spb_obdelnik.Down = True then // tlatko obdlnku
    begin
    if mys_sklik=1 then
      begin
        pb_maluj.Canvas.Pen.Mode:=pmXor;
        pb_maluj.Canvas.Rectangle(sX,sY,dX,dY);
        pb_maluj.Canvas.Rectangle(sX,sY,aX,aY);
      end;
    end;

  if spb_elipsa.Down = True then // tlatko elipsy
    begin
    if mys_sklik=1 then
      begin
        pb_maluj.Canvas.Pen.Mode := pmXor;
        pb_maluj.Canvas.Ellipse(sX,sY,dX,dY);
        pb_maluj.Canvas.Ellipse(sX,sY,aX,aY);
      end
    end;
    dX:=aX; // zskej doasn souadnice (pro XORovn objekt)
    dY:=aY;
end;

procedure TForm1.pb_malujMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  sX:=aX; // piad souadnice, kde bylo zmknuto tlatko
  sY:=aY;
  dX:=X;
  dY:=Y;
  mys_sklik:=1;
end;

procedure TForm1.pb_malujMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  mys_sklik:=0;

  // slou na zobrazen bez XORovanch barev :-)
  pb_maluj.Canvas.Pen.Color:=pnl_barva.Color;
  pb_maluj.Canvas.Pen.Mode := pmCopy;
  if(spb_usecka.Down = True) then // kdy skon pekreslovn seky, nakresli ji
    begin
      pb_maluj.Canvas.Pen.Mode:=pmCopy;
      pb_maluj.Canvas.MoveTo(sX,sY);
      pb_maluj.Canvas.LineTo(aX,aY);
    end;

  if(spb_elipsa.Down = True) then // kdy skon pekreslovn seky, nakresli ji
    begin
      pb_maluj.Canvas.MoveTo(sX,sY);
      pb_maluj.Canvas.Ellipse(sX,sY,aX,aY);
    end;

  if(spb_usecka.Down = True) then {namalovn definitivn ry}
    begin
      pb_maluj.Canvas.MoveTo(sX,sY);
      pb_maluj.Canvas.Lineto(aX,aY);
    end;

  if(spb_obdelnik.Down = True) then // kdy skon pekreslovn obdlnku, nakresli ji
    begin
      pb_maluj.Canvas.MoveTo(sX,sY);
      pb_maluj.Canvas.Rectangle(sX,sY,aX,aY);
    end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  spe_cara.Value:=5; // nastav velikost ry
  pb_maluj.Canvas.Pen.Width:=spe_cara.Value; // pia hodnotu e

  Form1.Color:=clWhite; // barva pozad

  pnl_barva.Color:=RGB(0,255,0); // nastav barcu ry
  cldlg_barva.Color:=pnl_barva.Color; // piazen barvy zkladnmu tlatku
  pb_maluj.Canvas.Pen.Color:=pnl_barva.Color; // piad hodnotu e

  pnl_pozadi.Color:=RGB(255,255,0); // nastav barcu vpln
  cldlg_pozadi.Color:=pnl_pozadi.Color; // piazen barvy zkladnmu tlatku
  pb_maluj.Canvas.Brush.Color:=pnl_pozadi.Color;

  pb_maluj.Color:=pnl_pozadi.Color; // pia hodnotu pozad, nevm pro to tu je, ale jinak nezmn barvu

  spb_cara.Down:=True; // nastav e se bude mrak rou od zatku
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
    spe_cara.Value:=spe_cara.Value-1; // zmenuj ru pi zatoen kolekem
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  spe_cara.Value:=spe_cara.Value+1; // zvtuj ru pi zatoen kolekem
end;

procedure TForm1.spe_caraChange(Sender: TObject); // kdy se zmn touka ry
begin
  pb_maluj.Canvas.Pen.Width:=spe_cara.Value;
end;

procedure TForm1.pb_malujClick(Sender: TObject);
begin
  if spb_kapatko.Down = True then // funkce kaptka
    begin
      pnl_barva.Color:=pb_maluj.Canvas.Pixels[aX,aY]; // zjist barvu na pozici
      pb_maluj.Canvas.Pen.Color:=pnl_barva.Color;
      spb_cara.Down:=True;
    end;

  if spb_plechovka.Down = True then // funcke plechovka
    begin
      pb_maluj.Canvas.Brush.Color:=pnl_pozadi.Color; // nastav barvu pozad
      pb_maluj.Canvas.FloodFill(aX,aY,pb_maluj.Canvas.Pixels[aX,aY],fssurface); // vybarvi :-)
    end;
end;

procedure TForm1.pnl_barvaClick(Sender: TObject); // zmna barvy ry
begin
  cldlg_barva.Color := pnl_barva.Color;
  if(cldlg_barva.Execute) then
    begin
    pnl_barva.Color:=cldlg_barva.Color;
    pb_maluj.Canvas.Pen.Color:=cldlg_barva.Color;
    end;
end;

procedure TForm1.pnl_pozadiClick(Sender: TObject); // zmna barvy pozad
begin
  cldlg_pozadi.Color := pnl_pozadi.Color;
  if(cldlg_pozadi.Execute) then
    begin
    pnl_pozadi.Color:=cldlg_pozadi.Color;
    pb_maluj.Canvas.Brush.Color:=cldlg_pozadi.Color;
    end;
end;

procedure TForm1.spb_obrazekClick(Sender: TObject);
var
  image_obr:TImage;
begin
  image_obr:=TImage.Create(Self);
  if(opd_obrazek.Execute) then
    begin
      image_obr.Picture.LoadFromFile(opd_obrazek.FileName);
      pb_maluj.Canvas.CopyRect(rect(0,0,pb_maluj.Width,pb_maluj.Height),image_obr.Canvas, rect(0,0,image_obr.Picture.Width, image_obr.Picture.Height));
    end;
end;

procedure TForm1.spb_smazatClick(Sender: TObject);
begin
  if spb_smazat.Down = True then // funkce smazat
    begin
    pb_maluj.Canvas.Pen.Width:=1; // nastav malej okraj
    pb_maluj.Canvas.Pen.Color:=pnl_pozadi.Color; // nastav barvu okraje, jako je pozad
    pb_maluj.Canvas.Brush.Color:=pnl_pozadi.Color; // nastav barvu pozad
    pb_maluj.Canvas.Rectangle(0,0,pb_maluj.Width, pb_maluj.Height); // nakresli obdlnk
    pb_maluj.Canvas.Pen.Color:=pnl_barva.Color; //vra barvu obraje
    pb_maluj.Canvas.Pen.Width:=spb_cara.Width; // vra ku ry

    spb_cara.Down:=True; // po zmazn vyber zase rovn
    end;
end;

end.
