unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    imgKresli: TImage;
    menu: TPanel;
    btn_konec: TButton;
    btn_bg: TButton;
    btn_home: TButton;
    btn_plot: TButton;
    btn_krajina: TButton;
    btn_napisy: TButton;
    btn_tree: TButton;
    btn_strecha: TButton;
    btn_orel: TButton;
    procedure btn_konecClick(Sender: TObject);
    procedure btn_bgClick(Sender: TObject);
    procedure btn_strechaClick(Sender: TObject);
    procedure btn_homeClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btn_plotClick(Sender: TObject);
    procedure btn_napisyClick(Sender: TObject);
    procedure btn_treeClick(Sender: TObject);
    procedure btn_krajinaClick(Sender: TObject);
    procedure btn_orelClick(Sender: TObject);
  private
    { Private declarations }
  public
    BarakX:integer; // pro uren zkladnch souadnic barku
    BarakY:integer;
    Bitmap:Tbitmap;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btn_konecClick(Sender: TObject);
begin
  Application.Terminate; // ukonen aplikace
end;

procedure TForm1.btn_bgClick(Sender: TObject);
begin
  imgKresli.Picture.LoadFromFile('.\Nebe.bmp'); //nate ze souboru a vypln plochu
end;


procedure TForm1.btn_strechaClick(Sender: TObject);
begin
  Bitmap := TBitmap.Create; // vytvo TBitmap
  Bitmap.LoadFromFile('./strecha.bmp'); // do Bitmap nate ze souboru obrzek
  imgKresli.Canvas.Pen.Width:=1;
  imgKresli.Canvas.Brush.Bitmap:=Bitmap; // bude vyplovat texturou
  imgKresli.Canvas.Polygon([Point(BarakX-30,BarakY), Point(BarakX+230,BarakY), Point(BarakX+100,BarakY-75)]); // nakresl mnohohelnk

  end;


procedure TForm1.btn_homeClick(Sender: TObject);
begin
  // bark
  imgKresli.Canvas.Brush.Color:= RGB(33,204,33); // uruje barvu v RGB reimu
  imgKresli.Canvas.Rectangle(BarakX,BarakY,BarakX+200,BarakY+150); // obdlnk na souadnice

  // komn
  Bitmap := TBitmap.Create;
  Bitmap.LoadFromFile('./cihla.bmp');
  imgKresli.Canvas.Brush.Bitmap:=Bitmap;
  imgKresli.Canvas.Rectangle(BarakX+150, BarakY, BarakX+180, BarakY-100);

  // okno
  imgKresli.Canvas.Brush.Color:=RGB(255,255,255);
  imgKresli.Canvas.Rectangle(BarakX+20, BarakY+20, BarakX+100, BarakY+80);

  // dvee
  imgKresli.Canvas.Brush.Color:=RGB(56,10,21);
  imgKresli.Canvas.Rectangle(BarakX+120, BarakY+30, BarakX+190, BarakY+150);
  imgKresli.Canvas.Pen.Width:=3;
  imgKresli.Canvas.Pen.Color:=RGB(90,90,90);
  imgKresli.Canvas.MoveTo(BarakX+130, BarakY+90); // pesu poten bod pro kreslen na souadnice
  imgKresli.Canvas.LineTo(BarakX+140,BarakY+90); // nakresl ru ze souadnic MoveTo na definovan
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BarakX:= 450; // X pozice barku
  BarakY:= 250; // Y pozice barku
  Form1.ClientWidth:=800; // velikost aplikace
  Form1.ClientHeight:=600; // velikost aplikace
  Form1.Top:=100; // pozice aplikace
  Form1.Left:=240; // pozice aplikace
end;

procedure TForm1.btn_plotClick(Sender: TObject);
var
  ploX, ploY, i, pom:integer;
begin
  ploX:=BarakX;
  ploY:=BarakY+100;
  imgKresli.Canvas.Pen.Width:=3; // tlouka ry
  imgKresli.Canvas.Pen.Color:=RGB(30,30,30);
  imgKresli.Canvas.MoveTo(ploX, ploY); // pesu poten bod pro kreslen na souadnice
  imgKresli.Canvas.LineTo(250,ploY); // nakresl ru ze souadnic MoveTo na definovan
  imgKresli.Canvas.MoveTo(ploX, ploY+30); // pesu poten bod pro kreslen na souadnice
  imgKresli.Canvas.LineTo(250,ploY+30); // nakresl ru ze souadnic MoveTo na definovan

  pom:=ploX-10;
  for i:=0 to 9 do // cyklus na kreslen vertiklnch klk v plot
  begin
    imgKresli.Canvas.Pen.Width:=3;
    imgKresli.Canvas.Pen.Color:=RGB(30,30,30);
    imgKresli.Canvas.MoveTo(pom, ploY-10);
    imgKresli.Canvas.LineTo(pom, ploY+40);
    pom:=pom-20;
  end;
end;

procedure TForm1.btn_napisyClick(Sender: TObject);
begin
  imgKresli.Canvas.Font.Height:=24;
  imgKresli.Canvas.Font.Color:=RGB(255,44,11);
  imgKresli.Canvas.TextOut(10, 10, 'Prvn nakreslen obrzek');
end;

procedure TForm1.btn_treeClick(Sender: TObject);
begin
  Bitmap:= TBitmap.Create;   // nacten textury  vody
  Bitmap.LoadFromFile('Vlnky.bmp');
  Bitmap.Transparent:=True; // zapnut transparentnosti
  Bitmap.TransparentColor:=Bitmap.Canvas.Pixels[0,0]; // vezme pruhlednost podle barvy pizexu na pozici
with
  imgKresli.Canvas do
  begin
  Pen.Color:= clMaroon;  // leva strana stromu
  Pen.Width:= 8;
  MoveTo(60,370);
  LineTo(60,500);

  MoveTo(80,320);     // prava strana stromu
  LineTo(80,500);

  MoveTo(100,270);
  LineTo(80,320);

  MoveTo(40,280);
  LineTo(60,370);

  Pen.Color:= clMaroon;   // spodni prostredni vetev
  Pen.Width:= 8;
  MoveTo(50,270);
  LineTo(70,340);

  Pen.Color:= clMaroon;   //vrchni prostedni vetev
  Pen.Width:= 8;
  MoveTo(90,270);
  LineTo(70,320);

  Brush.Bitmap:= Bitmap;
  Brush.Color:= clGreen;      //koruna stromu
  Brush.Style:=bsCross;
  Pen.Color:= clBlack;     //voda
  Pen.Width:= 1;
  Ellipse(70,220,170,320);
  Ellipse(5,170,135,310);
  end;
end;

procedure TForm1.btn_krajinaClick(Sender: TObject);
var
  i:integer;
begin
  //slunko
  imgKresli.Canvas.Pen.Color:=clWhite;
  imgKresli.Canvas.Pen.Width:=1;
  imgKresli.Canvas.Brush.Color:=clYellow;
  imgKresli.Canvas.Brush.Style:=bsSolid;

  imgKresli.Canvas.Ellipse(250-40, 100-40, 250+40, 100+40);

  imgKresli.Canvas.Pen.Color:=clYellow;
  imgKresli.Canvas.Pen.Style:=psDash;
  imgKresli.Canvas.Pen.Width:=1;

  imgKresli.Canvas.Brush.Style:=bsClear;

  for i:=0 to 11 do
  begin
      imgKresli.Canvas.MoveTo(250+Round(cos(i*pi/180*30)*70),100+Round(sin(i*pi/180*30)*70));
      imgKresli.Canvas.LineTo(250,100);
  end;


  // voda
  imgKresli.Canvas.Pen.Style:=psSolid;
  imgKresli.Canvas.Pen.Color:=clBlack;

  imgKresli.Canvas.Brush.Color:= clBlue;     //barva pozad vody
  imgKresli.Canvas.Ellipse(100,330,200,400); // vykresli kde je voda

  Bitmap:= TBitmap.Create;
  Bitmap.LoadFromFile('vlnky.bmp'); // nacten textury  vody
  imgKresli.Canvas.Brush.Bitmap:= Bitmap;
  SetROP2(imgKresli.Canvas.Handle,R2_MASKPEN); // nastav pomoc WinAPI zapnut prhlednosti
  imgKresli.Canvas.FloodFill(150,380,clBlack,fsBorder); // vypl oblast po rmeek texturou

  // cesta
  imgKresli.Canvas.Pen.Width:= 3;
  imgKresli.Canvas.MoveTo(0,490);
  imgKresli.Canvas.LineTo(1000,490);
  imgKresli.Canvas.MoveTo(0,450);
  imgKresli.Canvas.LineTo(1000,450);
  randomize;
  for i:=1 to 10000 do
    imgKresli.Canvas.Pixels[Random(imgKresli.Width), 450+Random(40)+1]:=clBlack;
end;

procedure TForm1.btn_orelClick(Sender: TObject);
var
  Bitmap:TBitmap;
begin
  Bitmap:=TBitmap.Create;

  try //zachytvn vjimek
    Bitmap.LoadFromFile('./orel_maly.bmp');
    Bitmap.Transparent:=True; // zapnut transparentnosti
    Bitmap.TransparentColor:=Bitmap.Canvas.Pixels[0,0]; // vezme pruhlednost podle barvy pizexu na pozici
    //Bitmap.TransparentColor:=RGB(255,255,255); // nasatven abrvy transparentnosti
      //monost nastavit treba: clWhite, clXXX
    Canvas.Draw(BarakX+70, BarakY-200,Bitmap);
  finally
    Bitmap.Free;
  end;
end;

end.
