unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Spin, ExtDlgs, ComCtrls, CheckLst;

type
  TForm1 = class(TForm)
    pnl_menu: TPanel;
    btn_konec: TButton;
    spb_cara: TSpeedButton;
    spb_usecka: TSpeedButton;
    spb_smazat: TSpeedButton;
    bvl_souradnice: TBevel;
    lbl_souradnice: TLabel;
    cldlg_barva: TColorDialog;
    spe_cara: TSpinEdit;
    spb_obdelnik: TSpeedButton;
    pnl_pozadi: TPanel;
    cldlg_pozadi: TColorDialog;
    pnl_barva: TPanel;
    spb_plechovka: TSpeedButton;
    spb_kapatko: TSpeedButton;
    opd_obrazek: TOpenPictureDialog;
    spb_obrazek: TSpeedButton;
    spb_elipsa: TSpeedButton;
    pnl_vrstvy: TPanel;
    btn_pridat: TButton;
    btn_smazat: TButton;
    pb_maluj: TImage;
    lbox_vrstvy: TCheckListBox;
    procedure btn_konecClick(Sender: TObject);
    procedure pb_malujMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure pb_malujMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pb_malujMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnl_pozadiClick(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure spe_caraChange(Sender: TObject);
    procedure pb_malujClick(Sender: TObject);
    procedure pnl_barvaClick(Sender: TObject);
    procedure spb_obrazekClick(Sender: TObject);
    procedure spb_smazatClick(Sender: TObject);
    procedure lbox_vrstvyClick(Sender: TObject);
    procedure btn_smazatClick(Sender: TObject);
    procedure btn_pridatClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbox_vrstvyContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure lbox_vrstvyDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lbox_vrstvyDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lbox_vrstvyMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
    aX, aY, sX, sY, dX, dY, mys_sklik:integer;
  end;

var
  Form1: TForm1;
  vrstva:array[1..20] of TImage;
  index, cislvr:integer;
  StartingPoint : TPoint;

implementation

{$R *.dfm}

procedure TForm1.btn_konecClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.DoubleBuffered:=True;
  spe_cara.Value:=5; // nastav defaultn tlouku ry
  pnl_barva.Color:=RGB(0,255,0); // nastav defaultn barvu ry
  pnl_pozadi.Color:=RGB(255,255,0); // nastav defaultn barvu vpln

  // tlatka
  cldlg_barva.Color:=pnl_barva.Color; // piazen barvy zkladnmu tlatku
  cldlg_pozadi.Color:=pnl_pozadi.Color; // piazen barvy zkladnmu tlatku

  // vrstvy
  lbox_vrstvy.DragMode := dmAutomatic; // pro automatickej Drag&Drop
  cislvr:=1;
  index:=1; // nastav 1 pro vrstvu
  btn_pridat.Click;
  lbox_vrstvy.Selected[cislvr-2]:=True; // e je vybran 1. vrstva

  // vrstva[index].Color:=pnl_pozadi.Color; // pia hodnotu pozad, nevm pro to tu je, ale jinak nezmn barvu

  pb_maluj.Canvas.Pen.Width:=spe_cara.Value; // pia tlouku e
  pb_maluj.Canvas.Pen.Color:=pnl_barva.Color; // pia barvu e
  pb_maluj.Canvas.Brush.Color:=pnl_pozadi.Color; // nastav barvu vpln
  spb_cara.Down:=True; // nastav e se bude mrat rou

end;

procedure TForm1.pb_malujMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  aX:=X; // nate do globlnch hodnot
  aY:=Y;
  pb_maluj.Canvas.Brush.Color:=pnl_pozadi.Color; // nastav barvu pozad
  pb_maluj.Canvas.Pen.Color:=pnl_barva.Color; // nastav barvu pozad

  lbl_souradnice.Caption:='Souadnice: ' + IntToStr(X) + ':'+ IntToStr(Y);

  if spb_cara.Down = True then // pokud je zmknuto tlatko Cara
    begin
    if mys_sklik = 1 then pb_maluj.Canvas.LineTo(aX,aY)
      else pb_maluj.Canvas.MoveTo(aX,aY);
    end;

  if spb_usecka.Down = True then // pokud je zmknuto tlatko Usecka
    begin
      case mys_sklik of
        0:  begin
              pb_maluj.Canvas.MoveTo(sX,sY); // posouvej kurzor na pozici, kdy nen stisknut tlatko

            end;
        1:  begin
            pb_maluj.Canvas.MoveTo(sX,sY);
            pb_maluj.Canvas.LineTo(dX,dY);
            pb_maluj.Canvas.Pen.Mode:=pmXor;
            pb_maluj.Canvas.MoveTo(sX,sY);
            pb_maluj.Canvas.LineTo(aX,aY);
            end;
    end;
   end;

  if spb_obdelnik.Down = True then // tlatko obdlnku
    begin
    if mys_sklik=1 then
      begin
        pb_maluj.Canvas.Pen.Mode:=pmXor;
        pb_maluj.Canvas.Rectangle(sX,sY,dX,dY);
        pb_maluj.Canvas.Rectangle(sX,sY,aX,aY);
      end;
    end;

  if spb_elipsa.Down = True then // tlatko elipsy
    begin
    if mys_sklik=1 then
      begin
        pb_maluj.Canvas.Pen.Mode := pmXor;
        pb_maluj.Canvas.Ellipse(sX,sY,dX,dY);
        pb_maluj.Canvas.Ellipse(sX,sY,aX,aY);
      end
    end;
    dX:=aX; // zskej doasn souadnice (pro XORovn objektu)
    dY:=aY;
end;

procedure TForm1.pb_malujMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  sX:=aX; // piad souadnice, kde bylo zmknuto tlatko
  sY:=aY;
  dX:=X;
  dY:=Y;
  mys_sklik:=1;
end;

procedure TForm1.pb_malujMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  mys_sklik:=0;

  // slou na zobrazen bez XORovanch barev :-)
  pb_maluj.Canvas.Pen.Color:=pnl_barva.Color;
  pb_maluj.Canvas.Pen.Mode := pmCopy;
  if(spb_usecka.Down = True) then // kdy skon pekreslovn seky, nakresli ji
    begin
      pb_maluj.Canvas.Pen.Mode:=pmCopy;
      pb_maluj.Canvas.MoveTo(sX,sY);
      pb_maluj.Canvas.LineTo(aX,aY);
    end;

  if(spb_elipsa.Down = True) then // kdy skon pekreslovn seky, nakresli ji
    begin
      pb_maluj.Canvas.MoveTo(sX,sY);
      pb_maluj.Canvas.Ellipse(sX,sY,aX,aY);
    end;

  if(spb_usecka.Down = True) then {namalovn definitivn ry}
    begin
      pb_maluj.Canvas.MoveTo(sX,sY);
      pb_maluj.Canvas.Lineto(aX,aY);
    end;

  if(spb_obdelnik.Down = True) then // kdy skon pekreslovn obdlnku, nakresli ho
    begin
      pb_maluj.Canvas.MoveTo(sX,sY);
      pb_maluj.Canvas.Rectangle(sX,sY,aX,aY);
    end;

end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
    spe_cara.Value:=spe_cara.Value-1; // zmenuj ru pi zatoen kolekem
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  spe_cara.Value:=spe_cara.Value+1; // zvtuj ru pi zatoen kolekem
end;

procedure TForm1.spe_caraChange(Sender: TObject); // kdy se zmn tolouka ry
begin
  vrstva[index].Canvas.Pen.Width:=spe_cara.Value;
  pb_maluj.Canvas.Pen.Width:=spe_cara.Value;  
end;

procedure TForm1.pb_malujClick(Sender: TObject);
var
  i:integer;
begin
  if spb_kapatko.Down = True then // funkce kaptka
    begin
    for i:=0 to lbox_vrstvy.ItemHeight do // cyklus pro vechny vrstvy
      begin
      pnl_barva.Color:=pb_maluj.Canvas.Pixels[aX,aY]; // zjist barvu na pozici
      vrstva[i].Canvas.Pen.Color:=pnl_barva.Color;
      spb_cara.Down:=True;
      end;
    end;

  if spb_plechovka.Down = True then // funcke plechovka
    begin
      pb_maluj.Canvas.Brush.Color:=pnl_pozadi.Color; // nastav barvu pozad
      pb_maluj.Canvas.FloodFill(aX,aY,vrstva[index].Canvas.Pixels[aX,aY],fssurface); // vybarvi :-)
    end;
end;

procedure TForm1.pnl_barvaClick(Sender: TObject); // zmina barvy ry
begin
  cldlg_barva.Color := pnl_barva.Color;
  if(cldlg_barva.Execute) then
    begin
    pnl_barva.Color:=cldlg_barva.Color;
    pb_maluj.Canvas.Pen.Color:=cldlg_barva.Color;
    end;
end;

procedure TForm1.pnl_pozadiClick(Sender: TObject); // zmna barvy pozad
begin
  cldlg_pozadi.Color := pnl_pozadi.Color;
  if(cldlg_pozadi.Execute) then
    begin
    pnl_pozadi.Color:=cldlg_pozadi.Color;
    pb_maluj.Canvas.Brush.Color:=cldlg_pozadi.Color;
    end;
end;

procedure TForm1.spb_obrazekClick(Sender: TObject);
var
  image_obr:TImage;
begin
  // funkce natn obrzku
  image_obr:=TImage.Create(Self);
  if(opd_obrazek.Execute) then
    begin
      image_obr.Picture.LoadFromFile(opd_obrazek.FileName);
      pb_maluj.Canvas.CopyRect(rect(0,0,vrstva[index].Width,vrstva[index].Height),image_obr.Canvas, rect(0,0,image_obr.Picture.Width, image_obr.Picture.Height));
    end;
end;

procedure TForm1.spb_smazatClick(Sender: TObject);
begin
  if spb_smazat.Down = True then // funkce smazat
    begin
    pb_maluj.Canvas.Pen.Width:=1; // nastav malej okraj
    pb_maluj.Canvas.Pen.Color:=pnl_pozadi.Color; // nastav barvu okraje, jako je pozad
    pb_maluj.Canvas.Brush.Color:=pnl_pozadi.Color; // nastav barvu pozad
    pb_maluj.Canvas.Rectangle(0,0,vrstva[index].Width, vrstva[index].Height); // nakresli obdlnk
    pb_maluj.Canvas.Pen.Color:=pnl_barva.Color; //vra? barvu obraje
    pb_maluj.Canvas.Pen.Width:=spb_cara.Width; // vra? oku ery

    spb_cara.Down:=True; // po smazn vyber zase crovn
    end;
end;


procedure TForm1.lbox_vrstvyClick(Sender: TObject);
var
  i:integer;
begin
  // pro zobrazen skrytch vrstev
  for i:=1 to cislvr-1 do
  begin
    vrstva[i].Visible:=True;
  end;


  vrstva[index]:=pb_maluj; // ulo aktuln obrzek do pole vrstva

  index:=StrToInt(lbox_vrstvy.Items.Strings[lbox_vrstvy.ItemIndex]); // do indexu ulo nzev vrstvy
  lbl_souradnice.Caption:='Vrstva '+IntToStr(index)+' celkem: '+IntToStr(cislvr-1); // vepi popis


  pb_maluj:=vrstva[index]; // nati ji do pb_maluj
  vrstva[index].BringToFront; // penes vrstvu dopedu
  pb_maluj.BringToFront; // penes nad n pbmaluj
end;

procedure TForm1.btn_pridatClick(Sender: TObject);
begin
  lbox_vrstvy.Items.Add(IntToStr(cislvr)); // pidej poloku do lboxu nastav jmno (index jinej!!!)
  vrstva[cislvr]:=TImage.Create(pb_maluj); // vytvo objekt
  vrstva[cislvr].Parent := Form1; // nastav rodie prvku
  vrstva[cislvr].Top:=0;
  vrstva[cislvr].Left:=0;
  vrstva[cislvr].Width:=pb_maluj.Width;
  vrstva[cislvr].Height:=pb_maluj.Height;
  vrstva[cislvr].Transparent:=True;

  vrstva[cislvr].Canvas.Pen.Width:=spe_cara.Value; // pia tlouku e
  vrstva[cislvr].Canvas.Pen.Color:=pnl_barva.Color; // piad barvu e
  vrstva[cislvr].Canvas.Brush.Color:=pnl_pozadi.Color; // pia barvu vpln
  spb_cara.Down:=True; // nastav e se bude mrat rou od zatku

  lbl_souradnice.Caption:='Vrstva '+IntToStr(cislvr)+' celkem: '+IntToStr(cislvr);

  vrstva[cislvr].BringToFront;
{
  pb_maluj:=vrstva[cislvr]; // do pb_maluj piad aktuln vrstvu
}
  pb_maluj.BringToFront; // penes pb_maluj do poped
  inc(cislvr); // piti k celkovmu potu vrstev
end;

procedure TForm1.btn_smazatClick(Sender: TObject);
begin
  vrstva[StrToInt(lbox_vrstvy.Items.Strings[lbox_vrstvy.ItemIndex])].Free;
  vrstva[StrToInt(lbox_vrstvy.Items.Strings[lbox_vrstvy.ItemIndex])].DestroyComponents;
  lbox_vrstvy.DeleteSelected;
  cislvr:=cislvr-1;
end;

procedure TForm1.lbox_vrstvyContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
var
  i:integer;
begin
  for i:=1 to cislvr-1 do
  begin
    vrstva[i].Visible:=False;
  end;
  lbox_vrstvy.Selected[lbox_vrstvy.ItemIndex]:=True;
  vrstva[lbox_vrstvy.ItemIndex].Visible:=True;
end;

procedure TForm1.lbox_vrstvyDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
   DropPosition, StartPosition: Integer;
   DropPoint: TPoint;
begin
  // (Drag&Drop)
  DropPoint.X := X;
  DropPoint.Y := Y;
  with Source as TListBox do
    begin
      StartPosition := ItemAtPos(StartingPoint,True);
      DropPosition := ItemAtPos(DropPoint,True);
      Items.Move(StartPosition, DropPosition);
    end;
end;

procedure TForm1.lbox_vrstvyDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  // (Drag&Drop)
  Accept := Source = lbox_vrstvy;
end;

procedure TForm1.lbox_vrstvyMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  // (Drag&Drop)
  StartingPoint.X := X; // pesun na souadnice
  StartingPoint.Y := Y;
end;

end.
