unit Unit1;

{

Hxmin=0      Hx       Hxmax = width
   ____________________
  /          /         \
 /          /           \
/__________/_____________\
Xmin=0     X             Xmax


  X - Xmin       Hx - Hxmin      Hx
------------ =  ------------ = -------
Xmax - Xmin     Hxmax - Hxmin   Hxmax


(X - Xmin) * Hxmax
------------------ = Hx
    Xmax - Xmin

}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    pnl_menu: TPanel;
    btn_original: TButton;
    btn_konec: TButton;
    edt_right: TEdit;
    edt_bottom: TEdit;
    edt_top: TEdit;
    edt_left: TEdit;
    bvl_souradnice: TBevel;
    lbl_souradnicepx: TLabel;
    lbl_souradnice: TLabel;
    lbl_souradnicebody: TLabel;
    img_graf: TImage;
    btn_plustop: TButton;
    btn_plusleft: TButton;
    btn_plusright: TButton;
    btn_plusbottom: TButton;
    btn_minus: TButton;
    btn_plus: TButton;
    procedure btn_konecClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure img_grafMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btn_originalClick(Sender: TObject);
    procedure btn_plusleftClick(Sender: TObject);
    procedure btn_plusrightClick(Sender: TObject);
    procedure btn_plustopClick(Sender: TObject);
    procedure btn_plusbottomClick(Sender: TObject);
    procedure edt_leftChange(Sender: TObject);
    procedure edt_topChange(Sender: TObject);
    procedure edt_bottomChange(Sender: TObject);
    procedure edt_rightChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btn_minusClick(Sender: TObject);
    procedure btn_plusClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Ymax, Xmax, Ymin, Xmin : real;
  puvX,puvY:integer; // lo by puvMys:TPoint, ale koho by to napadlo :D
  barvaPera:TColor;
  stylPera:TPenStyle;
  modPera:TPenMode;

implementation

uses Math;

{$R *.dfm}

function F (X: real):real;
begin
  F:= sin(3 * X) * (3 * X * X * X - 2 * X * X - X)/10;
end;

function Hx (X: real):integer;
begin
  Hx := round((X - Xmin) * Form1.img_graf.Width / (Xmax - Xmin));
end;

function Hy (Y: real):integer;
begin
  Hy := round((Form1.img_graf.Height - (Y - Ymin) * Form1.img_graf.Height / (Ymax - Ymin + 1)));
end;

procedure kresli_graf;
var
  X:real;
  Xplus: real; // prstek x++
begin
  Form1.img_graf.Canvas.Brush.Style:=bsSolid;
  Form1.img_graf.Canvas.Pen.Mode:=pmCopy;
  puvX:=-10000;
  puvY:=-10000;
  Form1.img_graf.Canvas.Pen.Style:=psSolid;
  Form1.img_graf.Canvas.Pen.Width:=2;
  Xplus := (Xmax - Xmin) / Form1.img_graf.Width;  // krok
  X := Xmin;
  Form1.img_graf.Canvas.MoveTo(Hx(X), Hy(F(X)));

  while X <= Xmax do
    begin
      Form1.img_graf.Canvas.LineTo(Hx(X), Hy(F(X)));
      X := X + Xplus;
    end;

end;

procedure kriz(X:integer; Y:integer);
begin
  Form1.img_graf.Canvas.Pen.Width:=1;
  Form1.img_graf.Canvas.Brush.Style:=bsClear;
  Form1.img_graf.Canvas.MoveTo(puvX,0);
  Form1.img_graf.Canvas.LineTo(puvX,Form1.img_graf.Height);
  Form1.img_graf.Canvas.MoveTo(0,puvY);
  Form1.img_graf.Canvas.LineTo(Form1.img_graf.Width,puvY);

  Form1.img_graf.Canvas.Rectangle(puvX-5,puvY-5,puvX+5+1,puvY+5+1); //

  // fce na posuv po kivce, koda, e nejde :(
  Form1.img_graf.Canvas.MoveTo(0,round(Hx(puvX)));
  Form1.img_graf.Canvas.LineTo(Form1.img_graf.Width,Hx(puvX));

  Form1.img_graf.Canvas.Pen.Mode:=pmXor;
  puvX := X;
  puvY := Y;
  Form1.img_graf.Canvas.MoveTo(X,0);
  Form1.img_graf.Canvas.LineTo(X,Form1.img_graf.Height);
  Form1.img_graf.Canvas.MoveTo(0,Y);
  Form1.img_graf.Canvas.LineTo(Form1.img_graf.Width,Y);

  Form1.img_graf.Canvas.Rectangle(X-5,Y-5,X+5+1,Y+5+1);

  // fce na posuv po kice, koda, e nejde :(
  Form1.img_graf.Canvas.MoveTo(0,round(Hx(X)));
  Form1.img_graf.Canvas.LineTo(Form1.img_graf.Width,Hx(X));
end;

procedure peroNastav; // uloen pvodnch hodnot barvy pera
begin
  barvaPera:=Form1.img_graf.Canvas.Pen.Color;
  modPera:=Form1.img_graf.Canvas.Pen.Mode;
  stylPera:=Form1.img_graf.Canvas.Pen.Style;
end;

procedure peroVrat; // naten pvodnch hodnot pera
begin
  Form1.img_graf.Canvas.Pen.Color:=barvaPera;
  Form1.img_graf.Canvas.Pen.Mode:=modPera;
  Form1.img_graf.Canvas.Pen.Style:=stylPera;
end;

procedure prekresli;
begin
  Form1.img_graf.Canvas.Pen.Mode:=pmCopy;
  Form1.img_graf.Canvas.Pen.Color:=clWhite; //RGB(RandomRange(0,80),RandomRange(0,80),RandomRange(0,80));
  Form1.img_graf.Canvas.Pen.Width:=1;
  Form1.img_graf.Canvas.Brush.Style:=bsSolid;
  Form1.img_graf.Canvas.Brush.Color:=clWhite; //RGB(RandomRange(100,255),RandomRange(100,255),RandomRange(100,255));
  Form1.img_graf.Canvas.Brush.Style:=bsSolid;
  Form1.img_graf.Canvas.Rectangle(0,0,Form1.img_graf.Width, Form1.img_graf.Height);
  Form1.img_graf.Canvas.Pen.Color:=clRed;
  kresli_graf;
end;

procedure TForm1.btn_konecClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Xmin:=10;
  Form1.btn_original.Click;
end;

procedure TForm1.img_grafMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  lbl_souradnicepx.Caption := 'Souadnice myi [px]: '+ IntToStr(X) +' : '+ IntToStr(Y);
  lbl_souradnice.Caption := 'Souadnice [px]: '+ IntToStr(Hx(X)) +' : '+ IntToStr(Hy(Y));
  kriz(X,Y);
  Form1.img_graf.Cursor := crNone; // skryje kurzor
end;

procedure TForm1.btn_originalClick(Sender: TObject);
begin
  edt_right.Text := IntToStr(20);
  edt_left.Text := IntToStr(-20);
  edt_top.Text := IntToStr(1000);
  edt_bottom.Text := IntToStr(-1000);
  prekresli;
end;

procedure TForm1.btn_plusleftClick(Sender: TObject);
begin
  edt_right.Text := IntToStr(StrToInt(edt_right.Text) - 4);
  edt_left.Text := IntToStr(StrToInt(edt_left.Text) - 4);
  prekresli;
end;

procedure TForm1.btn_plusrightClick(Sender: TObject);
begin
  edt_right.Text := IntToStr(StrToInt(edt_right.Text) + 4);
  edt_left.Text := IntToStr(StrToInt(edt_left.Text) + 4);
  prekresli;
end;

procedure TForm1.btn_plustopClick(Sender: TObject);
begin
  edt_top.Text := IntToStr(StrToInt(edt_top.Text) + 40);
  edt_bottom.Text := IntToStr(StrToInt(edt_bottom.Text) + 40);
  prekresli;
end;

procedure TForm1.btn_plusbottomClick(Sender: TObject);
begin
  edt_bottom.Text := IntToStr(StrToInt(edt_bottom.Text) - 40);
  edt_top.Text := IntToStr(StrToInt(edt_top.Text) - 40);
  prekresli;
end;

procedure TForm1.edt_leftChange(Sender: TObject);
begin
  Xmin:= StrToFloat(edt_left.Text);
  prekresli;
end;

procedure TForm1.edt_topChange(Sender: TObject);
begin
  try
    StrToFloat(edt_top.Text);
  except
  on EConvertError do
    edt_top.Text := IntToStr(1);
  end;
  Ymax:= StrToFloat(edt_top.Text);
  prekresli;
end;

procedure TForm1.edt_bottomChange(Sender: TObject);
begin
  Ymin:= StrToFloat(edt_bottom.Text);
  prekresli;
end;

procedure TForm1.edt_rightChange(Sender: TObject);
begin
  Xmax := StrToFloat(edt_right.Text);
  prekresli;
end;
procedure TForm1.FormShow(Sender: TObject);
begin
  prekresli;
end;

procedure TForm1.btn_minusClick(Sender: TObject);
begin
  edt_right.Text := IntToStr(StrToInt(edt_right.Text)-10);
  edt_left.Text := IntToStr(StrToInt(edt_left.Text)+10);
  edt_top.Text := IntToStr(StrToInt(edt_top.Text)-10);
  edt_bottom.Text := IntToStr(StrToInt(edt_bottom.Text)+10);
end;

procedure TForm1.btn_plusClick(Sender: TObject);
begin
  edt_right.Text := IntToStr(StrToInt(edt_right.Text)+10);
  edt_left.Text := IntToStr(StrToInt(edt_left.Text)-10);
  edt_top.Text := IntToStr(StrToInt(edt_top.Text)+10);
  edt_bottom.Text := IntToStr(StrToInt(edt_bottom.Text)-10);
end;

end.
