unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Spin, Math; {pid funkce}

type
  TForm1 = class(TForm)
    pnl_menu: TPanel;
    btn_konec: TButton;
    btn_vymazat: TButton;
    PB_KresliciPlocha: TPaintBox;
    Bevel1: TBevel;
    lbl_pocetKroku: TLabel;
    spe_pocetKroku: TSpinEdit;
    btn_napoveda: TButton;
    procedure btn_konecClick(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure spe_pocetKrokuChange(Sender: TObject);
    procedure PB_KresliciPlochaMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PB_KresliciPlochaPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  PocetBodu : byte;             // pocet zadanch bodu
  AktBod : byte;                // index aktulnho bodu
  P : array [1..4] of TPoint;   // pole rdcch bodu Bezierovy krivky
  PocetKroku:integer;           // pocet kroku pri vpoctu krivky
  NormalniBarvaBod, AktualniBarvaBodu : TColor; // barvy bod

implementation

{$R *.dfm}


procedure kolecko(bod : integer; barva: TColor);
begin
  Form1.PB_KresliciPlocha.Canvas.Pen.Color := barva;
  with P[bod] do
    begin
    Form1.PB_KresliciPlocha.Canvas.Arc(x-3,y-3,x+3,y+3,x-3,y+3,x-3,y+3);
    end;
end;

procedure  Bezier;
var
  x,y,index: integer;
  t: real;
begin
  Form1.PB_KresliciPlocha.Canvas.MoveTo(P[1].x,P[1].y);
  for index:=1 to PocetKroku do begin
    t:=Index/PocetKroku;
    x:=Round(P[1].x*Power(1-t,3)+P[2].x*3*t*Power(1-t,2)+P[3].x*3*Power(t,2)*(1-t)+P[4].x*Power(t,3));
    y:=Round(P[1].y*Power(1-t,3)+P[2].y*3*t*Power(1-t,2)+P[3].y*3*Power(t,2)*(1-t)+P[4].y*Power(t,3));
    Form1.PB_KresliciPlocha.Canvas.LineTo(x,y);
  end;
end;

procedure TForm1.btn_konecClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  spe_pocetKroku.Value := StrToInt(spe_pocetKroku.Text) - 1;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  spe_pocetKroku.Value := StrToInt(spe_pocetKroku.Text) + 1; 
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  spe_pocetKroku.Value := 6;
  PocetKroku := spe_pocetKroku.Value; // nate do promnn z spineditu
  NormalniBarvaBod:= clBlue;
  AktualniBarvaBodu:= clRed;
end;

procedure TForm1.spe_pocetKrokuChange(Sender: TObject);
begin
  PocetKroku := spe_pocetKroku.Value;
  Invalidate;
end;

procedure TForm1.PB_KresliciPlochaMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    begin
    if PocetBodu >= 4 then Exit;
    inc(PocetBodu);
    P[PocetBodu].X := X;
    P[PocetBodu].Y := Y;
    kolecko(PocetBodu, NormalniBarvaBod);
    Invalidate;
    end;
end;

procedure TForm1.PB_KresliciPlochaPaint(Sender: TObject);
var
  index: integer;
begin
  for index := 1 to PocetBodu do
    begin
      kolecko(index, NormalniBarvaBod);
    end;

  if PocetBodu = 4 then with Form1.PB_KresliciPlocha.Canvas do
    begin
    Pen.Color := clLime;
    MoveTo(P[4].X, P[4].Y);
    for index := 1 to PocetBodu do
      begin
        LineTo(P[index].X, P[index].Y);
      end;
    Pen.Color := NormalniBarvaBod;
    Bezier;
    end;
end;

end.
